#!/usr/bin/env python3
# -*- coding: utf-8 -*-
'''
Praktikum 8, lahendused
Viimati uuendatud 20.10.2024.
'''
#%% Ülesanne 1

a = ['Mari', 'Mai', 'Kalle', 'Aune']
print(sorted(a))

b = [23, 65, 77, 1, 34, 99, 854]
print(sorted(b, reverse=True))

#%% Ülesanne 1, teine lahendus

a = ['Mari', 'Mai', 'Kalle', 'Aune']
a.sort()
print(a)

b = [23, 65, 77, 1, 34, 99, 854]
b.sort(reverse=True)
print(b)

#%% Ülesanne 2

a = ['Mari', 'Bella', 'Kalle', 'Aune']
b = map(lambda x: 'Natsi-' + x, sorted(a))
print(list(b))

#%% Ülesanne 2, teine lahend

a = ['Mari', 'Bella', 'Kalle', 'Aune']
a.sort()
print(list(map(lambda x: 'Natsi-' + x, a)))

#%% Ülesanne 2, kolmas lahend

a = ['Mari', 'Bella', 'Kalle', 'Aune']
b = sorted(a)
c = map(lambda x: 'Natsi-' + x, b)
print(list(c))

#%% Ülesanne 3

arvud = [1, 2, 3, 4, 5, 6, 7, 3.3, 6.6, 4.4, 8.9]

kesk = sum(arvud) / len(arvud)
print('keskmine on', kesk)

tulem = filter(lambda x: x < kesk, arvud)  # Kui x väiksem, siis on True.
print(list(tulem))  # Kuna iteraator.

#%% Ülesanne 3, teine lahend

arvud = [1, 2, 3, 4, 5, 6, 7, 3.3, 6.6, 4.4, 8.9]

def loendi_keskmine(lst):
    '''funktsioon mis leiab etteantud loendi lst
    aritmeetilisel keskmise ja väljastab selle.'''
    kesk = sum(lst[:]) / len(lst)
    return kesk

keskmine = loendi_keskmine(arvud)
print('keskmine on', keskmine)

tulem = filter(lambda x: x < keskmine, arvud)  # kui x väiksem, kui on True
print(list(tulem))  # Kuna iteraator.

#%% Ülesanne 3, itereerin üle tulemi

arvud = [1, 2, 3, 4, 5, 6, 7, 3.3, 6.6, 4.4, 8.9]

def loendi_keskmine(lst):
    '''funktsioon mis leiab etteantud loendi lst
    aritmeetilisel keskmise ja väljastab selle.'''
    kesk = sum(lst[:]) / len(lst)
    return kesk

keskmine = loendi_keskmine(arvud)

def boolf(x):
    return x < keskmine

tulem = filter(boolf, arvud)

for i in tulem:  # Kuna tulem iteraator.
    print(i)
    
#%% Ülesanne 4, eraldi ridadel

nimed = ['juulia', 'juulius', 'silver', 'mare', 'juku', 'arno']

a = filter(lambda nimi: nimi[0] == 'j', nimed)
b = map(lambda x: x.capitalize() + ' Tipikas', a)
print(list(b))

#%% Ülesanne 4, kahe reaga

nimed = ['juulia', 'juulius', 'silver', 'mare', 'juku', 'arno']
print(list(map(lambda x: x.capitalize() + ' Tipikas', filter(lambda nimi: nimi[0] == 'j', nimed))))

#%% Ülesanne 4, ühe reaga, nagu küsitud

print(list(map(lambda x: x.capitalize() + ' Tipikas', filter(lambda nimi: nimi[0] == 'j', ['juulia', 'juulius', 'silver', 'mare', 'juku', 'arno']))))

#%% Ülesanne 5

lst = ['', [], 'a', (1,), 0, False, True, 100]

print(list(filter(bool, lst)))  # Keelatud vili on magus.
print(list(filter(None, lst)))  # Vastus.

#%% Ülesanne 6, lahend 1

def is_number(x):
    number_sets = (float, int)
    return isinstance(x, number_sets)

def is_string(x):
    return isinstance(x, str)

def round_add_neg(x):
    return round(x + 1) < 0 

data = ['x', -1, -2.5, 3, 4.5, 5, 6.7, [1, 2, 3], 'y', 'g']

tekstid = filter(is_string, data)
tekstid_sorted = sorted(tekstid)
print(tekstid_sorted)

numbrid = filter(is_number, data)
numbrid_x = filter(round_add_neg, numbrid)
print(list(numbrid_x))

#%% Ülesanne 6, lahend 2

data = ['x', -1, -2.5, 3, 4.5, 5, 6.7, [1, 2, 3], 'y', 'g']

tekstid = filter(lambda x: isinstance(x, str), data)
tekstid_sorted = sorted(tekstid)
print(tekstid_sorted)

numbrid = filter(lambda x: isinstance(x, (float, int)), data)
numbrid_x = filter(lambda x: round(x + 1) < 0, numbrid)
print(list(numbrid_x))

#%% Ülesanne 6, lahend 3

def is_number_round_add_neg(x):
    number_sets = (float, int)
    if isinstance(x, number_sets):
        return round(x + 1) < 0
    else:
        return False 
     
def is_string(x):
    return isinstance(x, str)

data = ['x', -1, -2.5, 3, 4.5, 5, 6.7, [1, 2, 3], 'y', 'g']

tekstid = filter(is_string, data)
tekstid_sorted = sorted(tekstid)
print(tekstid_sorted)

numbrid = filter(is_number_round_add_neg, data)
print(list(numbrid))


#%% Ülesanne 7, lahend 1

def is_lst_addrest(x):
    lst0 = ['', 'a', (1,), 0, False, True, 100] # Muutsin käsitsi, et ei tekiks rekursiooni.
    if isinstance(x, list):
        x.extend(lst0)
        return x
    else:
        return x

lst = ['', [], 'a', (1,), 0, False, True, 100]

print(list(map(is_lst_addrest, lst)))

#%% Ülesanne 7, lahend 2

lst = ['', [], 'a', (1,), 0, False, True, 100]

def is_lst_addrest(x):  # Sõltub globaalsest skoobist.
    if isinstance(x, list):
        no_list_inside = filter(lambda x: not isinstance(x, list), lst)  # Ei muuda algset listi käsitsi.
        x.extend(list(no_list_inside))  # Et ei tekiks rekursiooni.
        return x
    else:
        return x

print(list(map(is_lst_addrest, lst)))

#%% Ülesanne 7, lahend 3

lst = ['', [], 'a', (1,), 0, False, True, 100]

lst_of_lsts = []
for i in range(len(lst)):
    lst_of_lsts.append(lst)

def is_lst_addrest(x, lst0): # EI sõltub globaalsest skoobist.
    if isinstance(x, list):
        x.extend(filter(lambda x: not isinstance(x, list), lst0))  # Ei muuda algset listi käsitsi.
        return x
    else:
        return x

print(list(map(is_lst_addrest, lst, lst_of_lsts)))

#%% Ülesanne 8

raadius = [1, 2, 3, 4, 5, 6, 7.5, 9, 23.3]
pi = (7 + (6 + (5)**0.5)**0.5)**0.5

def pindala(r):
    '''Leiab ringi pindala mis vastab raaduisele r.'''
    return pi * r**2

tulem = map(pindala, raadius)
print(list(tulem))

#%% Ülesanne 8, itereerin üle tulemuse

raadius = [1, 2, 3, 4, 5, 6, 7.5, 9, 23.3]
pi = (7 + (6 + (5)**0.5)**0.5)**0.5

def pindala(r):
    '''Leiab ringi pindala mis vastab raaduisele r.'''
    return pi * r**2

tulem = map(pindala, raadius)
for i in tulem:  # Itereerin üle tulemuse.
    print(i)

#%% Ülesanne 8, kolmas lahend
    
raadius = [1, 2, 3, 4, 5, 6, 7.5, 9, 23.3]
pi = (7 + (6 + (5)**0.5)**0.5)**0.5

tulem = map(lambda r: pi*r**2, raadius)
for i in tulem:  # Itereerin üle tulemuse.
    print(i)

#%% Ülesanne 9

tulemus0 = 1 + 8 * 8 * 9

tulemus = 0
katse = 0
while tulemus != tulemus0 and katse < 3:
    sisend = input('\nSisesta "1 + 8 * 8 * 9" ja vajuta enter:')
    tulemus = eval(sisend)
    if tulemus == tulemus0:
        print('Tubli! Sinust saab hea käsutäitja! Teretulemast natsipartei liikmeks.')
        break  # Vajalik et ei trükiks viimast printi.
    else:
        print('Ei oska trükkida vä? Kas su isa teab, et sa oled jobu!')
    katse += 1
else:
    print('\nFuihhh, sa ei ole nats. Milline kergendus.')

#%% Ülesanne 10

code = '''
x = 'Juulius'
y = 'Tipikas'
z = ' '
nimi = x + z + y
for i in range(2, 5):
    print(f'{nimi} on {i}-kordne luuser.')
print('Keegi ei armasta mind!')
'''
x, y, z = 1, 2, 3 
exec(code)  # Huvitav mida see teeb?
vastus = x + z + y  # Kirjutati üle.
assert vastus == 6, 'Vastus peab olema: x + z + y = 6'

#%% Ülesanne 11

lst_1 = [None, False, 0, {}, [], '', 0j, 0+0j, 0.0, not True]

print(not all(lst_1))

#%% Ülesanne 12

# 1)
lst = ['a', 'b', '', [], 1.1, 2.1, 3, 8, 3, 8, -8, 2+3j, 8+8j, None, False]

def is_int_even(x):
    if isinstance(x, int) and x % 2 == 0:
        return True
    else:
        return False  # Kui seda ei lisa siis map väljastab None, bool(None) = False

bool_lst = map(is_int_even, lst)
print(any(bool_lst))

# 2)
def is_int_even2(x):
    if isinstance(x, int) and x % 2 == 0:
        return x

def is_positive(x):
    if x > 0:
        return True
    else:  # Pole tegelt vaja kuna 
        return False

lst_of_int = filter(is_int_even2, lst)
pos_lst_of_int = map(is_positive, lst_of_int)
print(all(pos_lst_of_int))

#%% Ülesanne 13

nimi = 'Mary'
assert nimi == 'Mari', f'Nimi on {nimi} see peaks olema Mari.'
print(f'Minu nimi on {nimi}.')

#%% Ülesanne 14

def cacheit(func):
    cache = {}  # Tühi sõnastik.
    def sisemine(n):
        tulem = cache.get(n)  # Kontrolli kas sõnastikus on tulem.
        if tulem is None:
             tulem = cache[n] = func(n)  # Lisan tulemi sõnastikku.
        return tulem
    return sisemine   # Väljastan funktsiooni.

def recursive_factorial(n):
    if n <= 1:
        return 1
    return recursive_factorial(n - 1) * n

rf = cacheit(recursive_factorial)  # Dekoreerin, ilma syntactic sugarita.
print(rf(500))

# Kasutades @ operaatorit, sama tulemus.
@cacheit
def recursive_factorial(n):
    if n <= 1:
        return 1
    return recursive_factorial(n - 1) * n

print()
print(recursive_factorial(500))

#%% Ülesanne 15

def fib(n):
    '''Leian fibonacci n-da jada liikme'''
    if n <= 2:
        return 1
    f1 = f2 = 1
    for i in range(n - 2):
        f1, f2 = f2, f1 + f2
    return f2

def rec_fib(n):
    '''Leiab n-da fibonacci jada liikme rekursiivselt'''
    if n <= 2:
        return 1
    return rec_fib(n - 2) + rec_fib(n - 1)

def test():
    assert fib(5) == rec_fib(5) == 5, 'fib(5) või rec_fib(5) jamab'
    assert fib(6) == rec_fib(6) == 8, 'fib(6) või rec_fib(6) jamab'
    assert fib(7) == rec_fib(7) == 13, 'fib(7) või rec_fib(7) jamab'
    print('Kontroll on läbitud, kõik OK!')

test()

#%% Ülesanne 15, teine lahend

def test(n1, n2, n3, v1, v2, v3):
    assert fib(n1) == rec_fib(n1) == v1, f'fib({n1}) või rec_fib({n1}) jamab'
    assert fib(n2) == rec_fib(n2) == v2, f'fib({n2}) või rec_fib({n2}) jamab'
    assert fib(n3) == rec_fib(n3) == v3, f'fib({n3}) või rec_fib({n3}) jamab'
    print('Kontroll on läbitud, kõik OK!')

test(5, 6, 7, 5, 8, 13)

#%% Ülesanne 15, kolmas lahend

def test(*args):
    for n, v in args:
        assert fib(n) == rec_fib(n) == v, f'fib({n}) või rec_fib({n}) jamab'
    print('Kontroll on läbitud, kõik OK!')

test((5, 5), (6, 8), (7, 13))  # Jrk. ja vastav jada liige.

#%% Ülesanne 16

def valine():
    salasona = 'Parool123456'
    def sise():
        print(salasona)
    return sise

salasona = valine()
salasona()

#%% Ülesanne 16, teine lahendus

def valine(salasona):
    def sise():
        print(salasona)
    return sise

salasona = valine('Parool123456')
salasona()

#%% Ülesanne 17

def dekoraator(func):   
    def sise(a, b, c):
        if a < 0:
            a = -a
        if b < 0:
            b = -b
        if c < 0:
            c = -c
        return func(a, b, c)
    return sise
 
def abs_sum(a, b, c):
    return a + b + c

abs_sum = dekoraator(abs_sum)
print(abs_sum(5, -5, -5))


# Kasutades @ operaatorit.
@dekoraator
def abs_sum(a, b, c):
    return a + b + c

print(abs_sum(-5, 5, -5))

#%% Ülesanne 18

def dekoraator(func):   
    def sise(*args):
        lst = []
        for i in args:
            if i < 0:
                i = -i
            lst.append(i)
        return func(*lst)
    return sise

def abs_sum(*args):
    s = 0
    for i in args:
        s += i
    return s

abs_sum = dekoraator(abs_sum)
print(abs_sum(5, -5, -5, 5))


# Kasutades @ operaatorit.
@dekoraator
def abs_sum(*args):
    return sum(args)  # Rumalam aga lühem.

print(abs_sum(-5, 5, -5, -5))

#%% Ülesanne 19

def korrutaja_arvuga(n):
    def korrutaja(arv):  # NB! Pesastatud funktsioonil on enda argument.
        return arv * n
    return korrutaja

korruta_neljaga = korrutaja_arvuga(4)
korruta_viiega = korrutaja_arvuga(5)

print('4 * 9 =', korruta_neljaga(9))
print('5 * 9 =', korruta_viiega(9))

#%% Ülesanne 20
    
def korrutaja_arvuga(n):
    def korrutaja(arv): 
        return arv * n
    return korrutaja   

for n in range(1, 10):
    f = korrutaja_arvuga(n)
    for arv in range(1, 10):       
        print(f'{n} * {arv} = {f(arv)}')
    print()

#%% Ülesanne 21

ilm = [('Tallinn', 47),
       ('Riiga', 41),
       ('Helsinki', 40),
       ('Stockholm', 39)]

F_to_C = lambda ilm: (ilm[0], (ilm[1] - 32)*5/9)

tulem = map(F_to_C, ilm)
print(list(tulem))

#%% Ülesanne 21, teine lahendus

ilm = [('Tallinn', 47),
       ('Riiga', 41),
       ('Helsinki', 40),
       ('Stockholm', 39)]

def F_to_C(i):
    return i[0], (i[1] - 32)*5/9

tulem = map(F_to_C, ilm)
print(list(tulem))

#%% Ülesanne 22

planeedid = [
    ('Mercury', 0.382,  0.06),
    ('Venus',   0.949,  0.82),
    ('Earth',   1.00,   1.00),
    ('Mars',    0.532,  0.11),
    ('Jupiter', 11.209, 317.8),
    ('Saturn',  9.449,  95.2),
    ('Uranus',  4.007,  14.6),
    ('Neptune', 3.883,  17.2)]

mass = lambda m: m[2]
s = sorted(planeedid, key=mass)
print(s)

# ilusam väljatrükk
print()
s1 = list(zip(*s))[0]
print(s1)

print()
for i in range(len(s)):
    print(s[i][0])

#%% Ülesanne 22, teine lahendus

planeedid = [
    ('Mercury', 0.382,  0.06),
    ('Venus',   0.949,  0.82),
    ('Earth',   1.00,   1.00),
    ('Mars',    0.532,  0.11),
    ('Jupiter', 11.209, 317.8),
    ('Saturn',  9.449,  95.2),
    ('Uranus',  4.007,  14.6),
    ('Neptune', 3.883,  17.2)]

def mass(m):
    return m[2]

s = sorted(planeedid, key=mass)
print(s)

# Ilusam väljatrükk.
print()
s1 = list(zip(*s))[0]
print(s1)

# Ilusam väljatrükk.
print()
for i in range(len(s)):
    print(s[i][0])

#%% Ülesanne 23

def dekoraator(func):   
    def sise(*args):
        neg_lst = []
        pos_lst = []
        for i in args:
            if i < 0:
                neg_lst.append(i)
            elif i > 0:
                pos_lst.append(i)
        if len(neg_lst) > len(pos_lst):
            return func(*neg_lst)
        elif len(neg_lst) < len(pos_lst):
            return func(*pos_lst)
        else:
            return func()
    return sise
 
def a_sum(*args):
    return sum(args)

a_sum = dekoraator(a_sum)

print(a_sum(-2, -2, 5, 5))

#%% Ülesanne 23, kasutades @ operaatorit

@dekoraator
def a_sum(*args):
    return sum(args)

print(a_sum(-5, 5))

#%% Ülesanne 23, teine lahendus

def a_sum(*args):
    tulem = 0
    for i in args:
        tulem += i
    return tulem

a_sum = dekoraator(a_sum)

print(a_sum(-5, -5, 5))

#%% Ülesanne 23, teine lahendus, kasutades @ operaatorit

@dekoraator
def a_sum(*args):
    tulem = 0
    for i in args:
        tulem += i
    return tulem

print(a_sum(-5, 5))










